VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Connect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "My Add-In"
' Code for Connect Class-Module (mostly the standart-code except for the Sub
' Show and for IDTExtensibility_OnConnection
' By J.M.Goebel
' This Code is Freeware if you use this code to develop new Application
' it may only be distributed as Freeware!


Option Explicit

Implements IDTExtensibility

Public FormDisplayed          As Boolean
Public VBInstance             As VBIDE.VBE
Dim mcbMenuCommandBar         As Office.CommandBarControl
Dim mfrmAddIn                 As New frmAddIn
Public WithEvents MenuHandler As CommandBarEvents   ' Ereignisbehandlungsroutine
Attribute MenuHandler.VB_VarHelpID = -1
                                                    ' fr die Befehlsleiste


Sub Hide()
    
    On Error Resume Next
    
    FormDisplayed = False
    mfrmAddIn.Hide
   
End Sub

Sub Show()
  
    On Error Resume Next
    
    If mfrmAddIn Is Nothing Then
        Set mfrmAddIn = New frmAddIn
    End If
    
    Set mfrmAddIn.VBInstance = VBInstance
    Set mfrmAddIn.Connect = Me
    FormDisplayed = True
    mfrmAddIn.Show
    mfrmAddIn.LoadComponents
End Sub

'------------------------------------------------------
' Diese Methode fgt das Add-In in VB ein.
'------------------------------------------------------
Private Sub IDTExtensibility_OnConnection(ByVal VBInst As Object, ByVal ConnectMode As vbext_ConnectMode, ByVal AddInInst As VBIDE.AddIn, custom() As Variant)
    
    On Error GoTo error_handler
    
    ' Speichern der VB-Instanz.
    Set VBInstance = VBInst
    
    ' Dieser Stelle eignet sich gut fr einen Haltepunkt,
    ' um verschiedene AddIn-Objekte, -Eigenschaften und
    ' -Methoden zu testen.
    Debug.Print VBInst.FullName

    If ConnectMode = vbext_cm_External Then
        ' Wird von der Assistenten-Symbolleiste zum
        ' Starten dieses Assistenten verwendet.
        Me.Show
    Else
        Set mcbMenuCommandBar = AddToAddInCommandBar("Code Completer")
        ' bergeben des Ereignisses an die Behandlungsroutine.
        Set Me.MenuHandler = VBInst.Events.CommandBarEvents(mcbMenuCommandBar)
    End If
  
    If ConnectMode = vbext_cm_AfterStartup Then
        If GetSetting(App.Title, "Settings", "DisplayOnConnect", "0") = "1" Then
            ' Anzeigen des Formulars beim Verbinden.
            Me.Show
        End If
    End If
  
    Exit Sub
    
error_handler:
    
    MsgBox Err.Description
    
End Sub

'------------------------------------------------------
' Diese Methode entfernt das Add-In aus VB.
'------------------------------------------------------
Private Sub IDTExtensibility_OnDisconnection(ByVal RemoveMode As vbext_DisconnectMode, custom() As Variant)
    
    On Error Resume Next
    
    ' Lschen des Befehlsleisteneintrags.
    mcbMenuCommandBar.Delete
    
    ' Beenden des Add-Ins.
    If FormDisplayed Then
        SaveSetting App.Title, "Settings", "DisplayOnConnect", "1"
        FormDisplayed = False
    Else
        SaveSetting App.Title, "Settings", "DisplayOnConnect", "0"
    End If
    
    Unload mfrmAddIn
    Set mfrmAddIn = Nothing

End Sub

Private Sub IDTExtensibility_OnStartupComplete(custom() As Variant)
    If GetSetting(App.Title, "Settings", "DisplayOnConnect", "0") = "1" Then
        ' Anzeigen des Formulars beim Verbinden.
        Me.Show
    End If
End Sub

Private Sub IDTExtensibility_OnAddInsUpdate(custom() As Variant)
'
End Sub

' Dieses Ereignis wird ausgelst, wenn auf das Men in der
' IDE (Intgrierte Entwicklungsumgebung) geklickt wird.
Private Sub MenuHandler_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    Me.Show
End Sub

Function AddToAddInCommandBar(sCaption As String) As Office.CommandBarControl
    Dim cbMenuCommandBar As Office.CommandBarControl  ' Befehlsleistenobjekt
    Dim cbMenu As Object
  
    On Error GoTo AddToAddInCommandBarErr
    
    ' Suchen des Mens "Add-Ins".
    Set cbMenu = VBInstance.CommandBars("Add-Ins")
    If cbMenu Is Nothing Then
        ' Nicht verfgbar. Fehler.
        Exit Function
    End If
    
    ' Hinzufgen zur Befehlsleiste.
    Set cbMenuCommandBar = cbMenu.Controls.Add(1)
    ' Festlegen der Beschriftung.
    cbMenuCommandBar.Caption = sCaption
    
    Set AddToAddInCommandBar = cbMenuCommandBar
    
    Exit Function
    
AddToAddInCommandBarErr:

End Function


